# -*- coding:cp932 -*-

import sys
import win32com.client
#COMNX̃CX^X쐬A}N萔(constants)pbP[WC|[g
from win32com.client import Dispatch, constants
#FemtetCOMNX`W[C|[g
from FemtetClassConst import FemtetClassName as const


#Main֐
def FemtetMain():
    global Femtet    #Femtetϐ͕ʊ֐ŗp̂globalϐƂĒ`
    
    Femtet = Dispatch(const.CFemtet) #CFemtetNX̃CX^X쐬
    
    #VKvWFNg
    if Femtet.OpenNewProject() == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    AnalysisSetUp()
    BodyAttributeSetUp()
    MaterialSetUp()
    BoundarySetUp()
    
    MakeModel() #f̍쐬
    
    Femtet.Gaudi.MeshSize = 0.2 #WbVTCY̐ݒ
    
    Femtet.Gaudi.Mesh() #bV̐
    Femtet.Solve() #͂̎s
    
    SamplingResult() #͌ʂ̒o


def AnalysisSetUp():
    #print("AnalysisSetUp")
    
    global Femtet #globalFemtetϐ𗘗p
    Als = Femtet.Analysis #͏NX
    
    #͏(Common)
    Als.AnalysisType = constants.GALILEO_C
    Als.Space = constants.TWO_C
    
    #(Galileo)
    Als.Galileo.bThermalStress = True
    Als.Galileo.bConstantTemp = True
    Als.Galileo.bStepAnalysis = True
    Als.Galileo.bResultDetail = True
    
    #M׏d(ThermalStress)
    Als.ThermalStress.Temp = 85
    Als.ThermalStress.TempRef = 220
        
    #bV̐ݒ(MeshProperty)
    Als.MeshProperty.bIsoParamElement = True
    Als.MeshProperty.bMeshG2 = True
    
    #Xebvݒ(StepAnalysis)
    Als.StepAnalysis.Set_Table_withoutTime(0, 1, 25)
    Als.StepAnalysis.Set_Table_withoutTime(1, 1, 120)
    Als.StepAnalysis.Set_Table_withoutTime(2, 1, 25)
    Als.StepAnalysis.Set_Table_withoutTime(3, 1, 85)


def BodyAttributeSetUp():
    #print("BodyAttributeSetUp")
    
    #Body̐ݒ
    BodyAttributeSetUp_BGA()
    BodyAttributeSetUp_PCB()
    BodyAttributeSetUp_UF()
    BodyAttributeSetUp_SB()


def BodyAttributeSetUp_BGA():
    #print("BodyAttributeSetUp_BGA")
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("BGA")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("BGA")
    
    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False
    BodyAttr.Length(Index).BodyThickness = 0.001
    

def BodyAttributeSetUp_PCB():
    #print("BodyAttributeSetUp_PCB")
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #bo{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("PCB")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("PCB")
    
    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False
    BodyAttr.Length(Index).BodyThickness = 0.001

def BodyAttributeSetUp_UF():
    #print("BodyAttributeSetUp_UF")
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("UF")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("UF")
    
    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False
    BodyAttr.Length(Index).BodyThickness = 0.001
    
    #͗̈(ActiveSolver)
    BodyAttr.ActiveSolver(Index).BirthStep = 3
    
def BodyAttributeSetUp_SB():
    #print("BodyAttributeSetUp_SB")
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("SB")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("SB")
    
    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False
    BodyAttr.Length(Index).BodyThickness = 0.001

def MaterialSetUp():
    #print("MaterialSetUp")
    
    #Material̐ݒ
    MaterialSetUp_SOLDER()
    MaterialSetUp_EPOXY()
    MaterialSetUp_GLASS_EPOXY()
    MaterialSetUp_UNDER_FILL()


def MaterialSetUp_SOLDER():
    #print("MaterialSetUp_SOLDER")
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("SOLDER")
    
    #Material Index̐ݒ
    Index = Mtl.Ask("SOLDER")
    
    #cW(Expansion)
    Mtl.Expansion(Index).sAlf = 21e-6
    
    #e萔(Elasticity)
    Mtl.Elasticity(Index).sY = 31e9
    Mtl.Elasticity(Index).Nu = 0.4
    
def MaterialSetUp_EPOXY():
    #print("MaterialSetUp_EPOXY")
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("EPOXY")
    
    #Material Index̐ݒ
    Index = Mtl.Ask("EPOXY")
        
    #cW(Expansion)
    Mtl.Expansion(Index).sAlf = 11e-6
    
    #e萔(Elasticity)
    Mtl.Elasticity(Index).sY = 19e9

def MaterialSetUp_GLASS_EPOXY():
    #print("MaterialSetUp_GLASS_EPOXY")
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("GLASS_EPOXY")
    
    #Material Index̐ݒ
    Index = Mtl.Ask("GLASS_EPOXY")
    
    #R(Resistivity)
    Mtl.Resistivity(Index).sRho = 1
    
    #cW(Expansion)
    Mtl.Expansion(Index).sAlf = 0
    Mtl.Expansion(Index).bAnIso = True
    Mtl.Expansion(Index).Set_vAlf(0, 11e-6)
    Mtl.Expansion(Index).Set_vAlf(1, 11e-6)
    Mtl.Expansion(Index).Set_vAlf(2, 55e-6)
    
    #e萔(Elasticity)
    Mtl.Elasticity(Index).sY = 28e9

def MaterialSetUp_UNDER_FILL():
    #print("MaterialSetUp_UNDER_FILL")
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("UNDER_FILL")
    
    #Material Index̐ݒ
    Index = Mtl.Ask("UNDER_FILL")
        
    #cW(Expansion)
    Mtl.Expansion(Index).sAlf = 90e-6
    
    #e萔(Elasticity)
    Mtl.Elasticity(Index).sY = 3.5e9

def BoundarySetUp():
    #print("BoundarySetUp")
    
    #Boundary̐ݒ
    BoundarySetUp_RESERVED_default()


def BoundarySetUp_RESERVED_default():
    #print("BoundarySetUp_RESERVED_default")
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("RESERVED_default")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("RESERVED_default")


def MakeModel():
    #print("MakeModel")
    
    global Femtet #globalFemtetϐ𗘗p
    Gaudi = Femtet.Gaudi #f[NX    
    BodyList = [] #Bodyzϐ̒`
    
    #f`悳Ȃݒ
    Femtet.RedrawMode = False
    
    #SetPlane
    Plane0 = Dispatch(const.CGaudiPlane) #CGaudiPlaneNX̃CX^X쐬
    Plane0.Location.SetCoord(0, 0, 0)
    Plane0.MainDirection.SetCoord(0, -1, 0)
    Plane0.RefDirection.SetCoord(1, 0, 0)
    Gaudi.SetPlane(Plane0)
    
    #CreateRect
    Point0 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point0.SetCoord(-15, 0, -1)
    tmpBody = Gaudi.CreateRect(Point0, 30, -1)
    BodyList.append(tmpBody) #Xgɒǉ
    
    #CreateRect
    Point1 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point1.SetCoord(-10, 0, 0)
    tmpBody = Gaudi.CreateRect(Point1, 20, 1)
    BodyList.append(tmpBody) #Xgɒǉ
    
    #CreateCircleFace
    Point2 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point2.SetCoord(-7.5, 0, -0.5)
    tmpBody = Gaudi.CreateCircleFace(Point2, 1)
    BodyList.append(tmpBody) #Xgɒǉ
    
    #Subtract
    BodyArray0 = [BodyList[0], BodyList[1]] #{fBz
    ret = BodyList[2].Subtract2_py(BodyArray0, 0) #Pythonp֐
    BodyList.append(ret[1][0]) #Xgɒǉ
    
    #Delete
    BodyList[2].Delete() #{fB폜BodyList[2]̃{fBQƂƗOG[ŗ
    
    #MatrixCopy
    ret = BodyList[3].MatrixCopy_py(5, 3, 0, 0, 0, 0) #Pythonp֐
    BodyList.extend(ret[1]) #Xgɕʂ̃Xg
    
    #CreateRect
    Point3 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point3.SetCoord(-10, 0, 0)
    ret = Gaudi.CreateRect(Point3, 20, -1)
    BodyList.append(ret) #Xgɒǉ
    
    #CreateReplica
    ret = BodyList[0].CreateReplica()
    BodyList.append(ret) #Xgɒǉ
    
    #Unite
    BodyArray3 = [BodyList[8]] #{fBz
    ret = BodyList[7].Unite_py(BodyArray3, True) #Pythonp֐
    BodyList.append(ret[1][0]) #Xgɒǉ
    
    #Fillet
    Vertex0 = BodyList[9].GetVertexByID(44) #CGaudiVertexf[^̎擾
    Vertex0.Fillet(1)
    
    #Fillet
    Vertex1 = BodyList[9].GetVertexByID(16) #CGaudiVertexf[^̎擾
    Vertex1.Fillet(1)
    
    #Subtract
    BodyArray5 = [BodyList[0]] #{fBz
    ret = BodyList[9].Subtract2_py(BodyArray5, 3) #Pythonp֐
    BodyList.append(ret[1][0]) #Xgɒǉ
    
    #Subtract
    BodyArray7 = [BodyList[3], BodyList[4], BodyList[5], BodyList[6]] #{fBz
    ret = BodyList[10].Subtract2_py(BodyArray7, 3) #Pythonp֐
    BodyList.extend(ret[1]) #Xgɕʂ̃Xg
    
    #CreateRect
    Point4 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point4.SetCoord(-10, 0, 0)
    ret = Gaudi.CreateRect(Point4, 20, 0.5)
    BodyList.append(ret) #Xgɒǉ
    
    #Move
    Vector0 = Dispatch(const.CGaudiVector) #CGaudiVectorNX̃CX^X쐬
    Vector0.SetCoord(0, 0, 0.5)
    BodyList[1].Move(Vector0)
    
    #BodyColor
    BodyList[0].Color = 0x8000
    
    #BodyColor
    BodyArray9 = [BodyList[3], BodyList[4], BodyList[5], BodyList[6]] #{fBz
    Gaudi.MultiSetBodyColor_py(BodyArray9, 0xc0c0c0) #Pythonp֐
    
    #BodyColor
    BodyList[1].Color = 0x808080
    
    #BodyColor
    BodyList[16].Color = 0x8080
    
    #BodyColor
    BodyArray10 = [BodyList[11], BodyList[12], BodyList[13], BodyList[14], BodyList[15]] #{fBz
    Gaudi.MultiSetBodyColor_py(BodyArray10, 0x4080ff) #Pythonp֐
    
    #SetName
    BodyList[1].SetName("BGA", "EPOXY")
    
    #SetName
    BodyList[16].SetName("BGA", "GLASS_EPOXY")
    
    #SetName
    BodyList[0].SetName("PCB", "GLASS_EPOXY")
    
    #SetName
    BodyArray11 = [BodyList[3], BodyList[4], BodyList[5], BodyList[6]] #{fBz
    Gaudi.MultiSetName_py(BodyArray11, "SB", "SOLDER") #Pythonp֐
    
    #SetName
    BodyArray12 = [BodyList[11], BodyList[12], BodyList[13], BodyList[14], BodyList[15]] #{fBz
    Gaudi.MultiSetName_py(BodyArray12, "UF", "UNDER_FILL") #Pythonp֐
        
    #SetPlane
    Plane1 = Dispatch(const.CGaudiPlane) #CGaudiPlaneNX̃CX^X쐬
    Plane1.Location.SetCoord(0, 0, 0)
    Plane1.MainDirection.SetCoord(0, -1, 0)
    Plane1.RefDirection.SetCoord(1, 0, 0)
    Gaudi.SetPlane(Plane1)
    
    #print("BodyList:" + str(len(BodyList)) + "")
    
    #fĕ`悵܂
    Femtet.Redraw()


def SamplingResult():
    #print("SamplingResult")
    
    global Femtet #globalFemtetϐ𗘗p
    Gogh = Femtet.Gogh #͌ʃNX
    
    #Femtet.SavePDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@Cۑ܂
    #Femtet.OpenPDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@CJ܂
    Femtet.OpenCurrentResult(True)#ԃt@ČʂJ܂
        
    #tB[h̐ݒ
    Gogh.Galileo.Vector = constants.GALILEO_DISPLACEMENT_C

    #[h̐ݒ
    Gogh.Galileo.Mode = 3

    #ψʃxNg\
    Gogh.bVector = True
    
    #ől̎擾
    ret = Gogh.Galileo.GetMAXVectorPoint_py(constants.VEC_C, constants.CMPX_REAL_C) #Pythonp֐
    if ret[0] == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    PosMax = ret[1] #ől̍W[x, y, z]
    ResultMax = ret[2] #ől
    
    #őlWo͂ɕ\
    print("[Max value] : %e\n    coordinates : (%e, %e, %e)" % (ResultMax, PosMax[0], PosMax[1], PosMax[2]))
    
    #ŏl̎擾
    ret = Gogh.Galileo.GetMINVectorPoint_py(constants.VEC_C, constants.CMPX_REAL_C) #Pythonp֐
    if ret[0] == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    PosMin = ret[1] #ŏl̍W[x, y, z]
    ResultMin = ret[2] #ŏl
    
    #őlWo͂ɕ\
    print("[Min value] : %e\n    coordinates : (%e, %e, %e)" % (ResultMin, PosMin[0], PosMin[1], PosMin[2]))
    
    #CӍW̌vZʂ̎擾
    coord = [-2, 0, 1]
    ret = Gogh.Galileo.GetVectorAtPoint_py(coord[0], coord[1], coord[2]) #Pythonp֐
    if ret[0] == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    val = (coord[0], coord[1], coord[2], ret[1][0].Real, ret[1][1].Real, ret[1][2].Real)
    print("[coordinates] : (%e, %e, %e)\n      value : %e, %e, %e" % val)


# Main֐̎s
if __name__ == '__main__':
    FemtetMain()

