# -*- coding:cp932 -*-

import sys
import win32com.client
#COMNX̃CX^X쐬A}N萔(constants)pbP[WC|[g
from win32com.client import Dispatch, constants
#FemtetCOMNX`W[C|[g
from FemtetClassConst import FemtetClassName as const


#Main֐
def FemtetMain():
    global Femtet    #Femtetϐ͕ʊ֐ŗp̂globalϐƂĒ`
    
    Femtet = Dispatch(const.CFemtet) #CFemtetNX̃CX^X쐬
    
    #VKvWFNg
    if Femtet.OpenNewProject() == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    #f[^x[X̐ݒ
    AnalysisSetUp()
    BodyAttributeSetUp()
    MaterialSetUp()
    BoundarySetUp()
    
    MakeModel() #f̍쐬
    
    Femtet.Gaudi.MeshSize = 2.5 #WbVTCY̐ݒ
    
    Femtet.Gaudi.Mesh() #bV̐
    Femtet.Solve() #͂̎s
    
    #͌ʂ̒o
    SamplingResult() 


def AnalysisSetUp():
    
    global Femtet #globalFemtetϐ𗘗p
    Als = Femtet.Analysis #͏NX
    
    #͏(Common)
    Als.AnalysisType = constants.WATT_C
    
    #bV̐ݒ(MeshProperty) 
    Als.MeshProperty.bMeshG2 = True

def BodyAttributeSetUp():
    
    #Body̐ݒ
    BodyAttributeSetUp_VOL2()
    BodyAttributeSetUp_VOL1()


def BodyAttributeSetUp_VOL2():
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("VOL2")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("VOL2")
    
    #------- M(HeatSource) -------
    BodyAttr.HeatSource(Index).Q = 1.0

    
def BodyAttributeSetUp_VOL1():

    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX

    #Body̒ǉ
    BodyAttr.Add("VOL1")

    #Body Index̐ݒ
    Index = BodyAttr.Ask("VOL1")


def MaterialSetUp():
    #print("MaterialSetUp")
    
    #Material̐ݒ
    MaterialSetUp_006_KXG|LV()
    MaterialSetUp_001_A~i()


def MaterialSetUp_006_KXG|LV():
    
    global Femtet #globalFemtetϐ𗘗p 
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("006_KXG|LV")
 
    #Material Index̐ݒ
    Index = Mtl.Ask("006_KXG|LV")

    #------- M(SpecificHeat) -------
    Mtl.SpecificHeat(Index).C = 0.795e3

    #------- x(Density) -------
    Mtl.Density(Index).Dens = 1800

    #------- M`(ThermalConductivity) -------
    Mtl.ThermalConductivity(Index).sRmd = 0.293

    #------- cW(Expansion) -------
    Mtl.Expansion(Index).sAlf = 2.3e-5

    #------- e萔(Elasticity) -------
    Mtl.Elasticity(Index).sY = 21e9


def MaterialSetUp_001_A~i():
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX

    #Material̒ǉ
    Mtl.Add ("001_A~i")


    #Material Index̐ݒ
    Index = Mtl.Ask("001_A~i") 

    #------- x(Density) -------
    Mtl.Density(Index).Dens = 3800

    #------- M`(ThermalConductivity) -------
    Mtl.ThermalConductivity(Index).sRmd = 33

    #------- cW(Expansion) -------
    Mtl.Expansion(Index).sAlf = 5.4e-6

    #------- e萔(Elasticity) -------
    Mtl.Elasticity(Index).sY = 220e9

def BoundarySetUp():
    #print("BoundarySetUp")
    
    #Boundary̐ݒ
    BoundarySetUp_RESERVED_default()

def BoundarySetUp_RESERVED_default():
    #print("BoundarySetUp_RESERVED_default")
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("RESERVED_default")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("RESERVED_default")
    
    #------- M(Thermal) -------
    Bnd.Thermal(Index).Condition = constants.HEAT_TRANSFER_C
    Bnd.Thermal(Index).bConAuto = True
    Bnd.Thermal(Index).bSetRadioSetting = True

    #------- _x(RoomTemp) -------
    Bnd.Thermal(Index).RoomTemp.TempType = constants.TEMP_DIRECT_C

    #------- t(Emittivity) -------
    Bnd.Thermal(Index).Emittivity.Eps = 0.999


def MakeModel():
    #print("MakeModel")
    
    global Femtet #globalFemtetϐ𗘗p
    Gaudi = Femtet.Gaudi #f[NX    
    BodyList = [] #Bodyzϐ̒`
    
    #f`悳Ȃݒ
    Femtet.RedrawMode = False

    #------- CreateBox -------
    Point0 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point0.SetCoord(-25, -25, -1)
    tmpBody = Gaudi.CreateBox(Point0, 50, 50, 2)
    BodyList.append(tmpBody) #Xgɒǉ

    #------- CreateBox -------
    Point1 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point1.SetCoord(-10, -10, 1)
    tmpBody = Gaudi.CreateBox(Point1, 20, 20, 2)
    BodyList.append(tmpBody) #Xgɒǉ

    #------- SetName -------
    BodyList[0].SetName("VOL1", "006_KXG|LV")

    #------- SetName -------
    BodyList[1].SetName("VOL2", "001_A~i")
      
    #fĕ`悵܂
    Femtet.Redraw()


def SamplingResult():
    #print("SamplingResult")
    
    global Femtet #globalFemtetϐ𗘗p
    Gogh = Femtet.Gogh #͌ʃNX
    
    Femtet.SavePDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@Cۑ܂
    Femtet.OpenPDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@CJ܂
       
    #tB[h̐ݒ
    Gogh.Watt.Potential = constants.WATT_TEMPERATURE_C

    #R^[}\
    Gogh.bContour_G = True

    #ől̎擾
    ret = Gogh.Watt.GetMAXPotentialPoint_py(constants.CMPX_REAL_C) #Pythonp֐
    if ret[0] == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    PosMax = ret[1] #ől̍W[x, y, z]
    ResultMax = ret[2] #ől
    
    #őlWo͂ɕ\
    print("[Max value] : %e\n    coordinates : (%e, %e, %e)" % (ResultMax, PosMax[0], PosMax[1], PosMax[2]))
    
    #ŏl̎擾
    ret = Gogh.Watt.GetMINPotentialPoint_py(constants.CMPX_REAL_C) #Pythonp֐
    if ret[0] == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    PosMin = ret[1] #ŏl̍W[x, y, z]
    ResultMin = ret[2] #ŏl
    
    #őlWo͂ɕ\
    print("[Min value] : %e\n    coordinates : (%e, %e, %e)" % (ResultMin, PosMin[0], PosMin[1], PosMin[2]))
    
    #CӍW̌vZʂ̎擾
    coord = [0, 0, 0]
    ret = Gogh.Watt.GetPotentialAtPoint_py(coord[0], coord[1], coord[2]) #Pythonp֐
    if ret[0] == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    
    val = (coord[0], coord[1], coord[2], ret[1].Real)
    print("[coordinates] : (%e, %e, %e)\n      value : %e" % val)

    
# Main֐̎s
if __name__ == '__main__':
    FemtetMain()

